//+------------------------------------------------------------------+
//|                                                        DV(2).mq4 |
//|                                                                  |
//| DV(2) originally developed by David Varadi                       |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue

//
//
//
//
//

extern int boundPeriod = 252;

//
//
//
//
//

double dv2bounded[];
double dv2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,dv2bounded);
      SetIndexBuffer(1,dv2);
   IndicatorShortName("DV(2) bounded ("+boundPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      if (i==Bars-1)
            dv2[i] =  (Close[i]/(High[i]+Low[i])*2.0-1.0);
      else  dv2[i] = ((Close[i]/(High[i]+Low[i])*2.0-1.0)+(Close[i+1]/(High[i+1]+Low[i+1])*2.0-1.0))/2.0;
      
      //
      //
      //
      //
      //
      
      double max = dv2[ArrayMaximum(dv2,boundPeriod,i)];
      double min = dv2[ArrayMinimum(dv2,boundPeriod,i)];
      if (max!=min)
            dv2bounded[i] = 100.0*(dv2[i]-min)/(max-min);
      else  dv2bounded[i] = 50.0;
   }

   //
   //
   //
   //
   //
      
   return(0);      
}